package cn.com.tenlion.projectconfig.service.projectconfig;

import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;
import cn.com.tenlion.projectconfig.pojo.dtos.projectconfig.ProjectConfigDTO;
import cn.com.tenlion.projectconfig.pojo.vos.projectconfig.ProjectConfigVO;
import cn.com.tenlion.projectconfig.pojo.bos.projectconfig.ProjectConfigBO;
import cn.com.tenlion.projectconfig.pojo.pos.projectconfig.ProjectConfigPO;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IProjectConfigService
 * @Description: CBC项目配置管理表
 * @Author: CodeFactory
 * @Date: 2021-08-12 13:54:56
 * @Version: 3.0
 **/
public interface IProjectConfigService {

    /**
     * 新增CBC项目配置管理表
     *
     * @param projectConfigVO
     * @return
     */
    void save(ProjectConfigVO projectConfigVO);

    /**
     * 新增CBC项目配置管理表
     *
     * @param token
     * @param projectConfigVO
     * @return
     */
    void save(String token, ProjectConfigVO projectConfigVO);

    /**
     * 新增CBC项目配置管理表
     *
     * @param projectConfigVO
     * @return projectConfigId
     */
    String saveReturnId(ProjectConfigVO projectConfigVO);

    /**
     * 新增CBC项目配置管理表
     *
     * @param token
     * @param projectConfigVO
     * @return projectConfigId
     */
    String saveReturnId(String token, ProjectConfigVO projectConfigVO);

    /**
     * 删除CBC项目配置管理表
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除CBC项目配置管理表
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除CBC项目配置管理表（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改CBC项目配置管理表
     *
     * @param projectConfigId
     * @param projectConfigVO
     * @return
     */
    void update(String projectConfigId, ProjectConfigVO projectConfigVO);

    /**
     * 修改CBC项目配置管理表
     *
     * @param token
     * @param projectConfigId
     * @param projectConfigVO
     * @return
     */
    void update(String token, String projectConfigId, ProjectConfigVO projectConfigVO);

    /**
     * CBC项目配置管理表详情
     *
     * @param params 参数Map
     * @return
     */
    ProjectConfigDTO get(Map<String, Object> params);

    /**
     * CBC项目配置管理表详情
     *
     * @param projectConfigId
     * @return
     */
    ProjectConfigDTO get(String projectConfigId);

    /**
     * CBC项目配置管理表详情
     *
     * @param params 参数Map
     * @return
     */
    ProjectConfigBO getBO(Map<String, Object> params);

    /**
     * CBC项目配置管理表详情
     *
     * @param projectConfigId
     * @return
     */
    ProjectConfigBO getBO(String projectConfigId);

    /**
     * CBC项目配置管理表详情
     *
     * @param params 参数Map
     * @return
     */
    ProjectConfigPO getPO(Map<String, Object> params);

    /**
     * CBC项目配置管理表详情
     *
     * @param projectConfigId
     * @return
     */
    ProjectConfigPO getPO(String projectConfigId);

    /**
     * CBC项目配置管理表列表
     *
     * @param params
     * @return
     */
    List<ProjectConfigDTO> list(Map<String, Object> params);

    /**
     * CBC项目配置管理表列表
     *
     * @param params
     * @return
     */
    List<ProjectConfigBO> listBO(Map<String, Object> params);

    /**
     * CBC项目配置管理表列表
     *
     * @param params
     * @return
     */
    List<ProjectConfigPO> listPO(Map<String, Object> params);

    /**
     * CBC项目配置管理表分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<ProjectConfigDTO>> listPage(ListPage page);

    /**
     * CBC项目配置管理表统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

    void updateSwitch(String projectConfigId, Boolean projectConfigSwitch);

    ProjectConfigDTO getByKey(String configKey);
}